Index: azure_iot_hub/trunk/azure_iothub/c-utility/adapters/uniqueid_stub.c
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/adapters/uniqueid_stub.c	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/adapters/uniqueid_stub.c	(revision 389)
@@ -0,0 +1,76 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#include <stdlib.h>
+#include <stdint.h>
+#include "azure_c_shared_utility/uniqueid.h"
+#include "azure_c_shared_utility/xlogging.h"
+#include <time.h>
+
+MU_DEFINE_ENUM_STRINGS(UNIQUEID_RESULT, UNIQUEID_RESULT_VALUES);
+
+static const char tochar[] = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
+static void generate128BitUUID(unsigned char* arrayOfByte)
+{
+    size_t arrayIndex;
+
+    for (arrayIndex = 0; arrayIndex < 16; arrayIndex++)
+    {
+        arrayOfByte[arrayIndex] = (unsigned char)rand();
+    }
+
+    //
+    // Stick in the version field for random uuid.
+    //
+    arrayOfByte[7] &= 0x0f; //clear the bit field
+    arrayOfByte[7] |= 0x40; //set the ones we care about
+
+    //
+    // Stick in the variant field for the random uuid.
+    //
+    arrayOfByte[8] &= 0xf3; // Clear
+    arrayOfByte[8] |= 0x08; // Set
+
+}
+
+// TODO: The User will need to call srand before calling this function
+UNIQUEID_RESULT UniqueId_Generate(char* uid, size_t len)
+{
+    UNIQUEID_RESULT result;
+    unsigned char arrayOfChar[16];
+
+    /* Codes_SRS_UNIQUEID_07_002: [If uid is NULL then UniqueId_Generate shall return UNIQUEID_INVALID_ARG] */
+    /* Codes_SRS_UNIQUEID_07_003: [If len is less then 37 then UniqueId_Generate shall return UNIQUEID_INVALID_ARG] */
+    if (uid == NULL || len < 37)
+    {
+        result = UNIQUEID_INVALID_ARG;
+        LogError("Buffer Size is Null or length is less then 37 bytes");
+    }
+    else 
+    {
+        size_t arrayIndex;
+        size_t shiftCount;
+        size_t characterPosition = 0;
+
+        /* Codes_SRS_UNIQUEID_07_001: [UniqueId_Generate shall create a unique Id 36 character long string.] */
+        generate128BitUUID(arrayOfChar);
+        for (arrayIndex = 0; arrayIndex < 16; arrayIndex++)
+        {
+            for (shiftCount = 0; shiftCount <= 1; shiftCount++)
+            {
+                char hexChar = tochar[arrayOfChar[arrayIndex] & 0xf];
+                if ((characterPosition == 8) || (characterPosition == 13) || (characterPosition == 18) || (characterPosition == 23))
+                {
+                    uid[characterPosition] = '-';
+                    characterPosition++;
+                }
+                uid[characterPosition] = hexChar;
+                characterPosition++;
+                arrayOfChar[arrayIndex] = arrayOfChar[arrayIndex] >> 4;
+            }
+        }
+        uid[characterPosition] = 0;
+        result = UNIQUEID_OK;
+    }
+    return result;
+}
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/agenttime.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/agenttime.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/agenttime.h	(revision 389)
@@ -0,0 +1,63 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file agenttime.h
+*	@brief Function prototypes for time related functions.
+*
+*	@details These functions are implemented with C standard functions,
+*	and therefore they are platform independent. But then a platform
+*	can replace these functions with its own implementation as necessary.
+*/
+
+#ifndef AGENTTIME_H
+#define AGENTTIME_H
+
+#include <time.h>
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C"
+{
+#endif
+
+/** @brief Get current calendar time.
+*
+*	@details This function provides the same functionality as the
+*	standard C @c time() function.
+*/
+MOCKABLE_FUNCTION(, time_t, get_time, time_t*, currentTime);
+
+/** @brief Get UTC in @c tm struct.
+*
+*	@details This function provides the same functionality as the
+*	standard C @c gmtime() function.
+*/
+MOCKABLE_FUNCTION(, struct tm*, get_gmtime, time_t*, currentTime);
+
+/** @brief Get current time representation of the given calendar time.
+*
+*	@details This function provides the same functionality as the
+*	standard C @c mktime() function.
+*/
+MOCKABLE_FUNCTION(, time_t, get_mktime, struct tm*, cal_time);
+
+/** @brief Gets a C-string representation of the given time.
+*
+*	@details This function provides the same functionality as the
+*	standard C @c ctime() function.
+*/
+MOCKABLE_FUNCTION(, char*, get_ctime, time_t*, timeToGet);
+
+/** @brief Gets the difference in seconds between @c stopTime and
+*	@c startTime.
+*
+*	@details This function provides the same functionality as the
+*	standard C @c difftime() function.
+*/
+MOCKABLE_FUNCTION(, double, get_difftime, time_t, stopTime, time_t, startTime);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif  // AGENTTIME_H
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/azure_base64.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/azure_base64.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/azure_base64.h	(revision 389)
@@ -0,0 +1,83 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file base64.h
+*    @brief Prototypes for functions related to encoding/decoding
+*    a @c buffer using standard base64 encoding.
+*/
+
+#ifndef BASE64_H
+#define BASE64_H
+
+#include "azure_c_shared_utility/strings.h"
+#include "azure_c_shared_utility/buffer_.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C" {
+#else
+#include <stddef.h>
+#endif
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+
+/**
+ * @brief    Base64 encodes a buffer and returns the resulting string.
+ *
+ * @param    input    The buffer that needs to be base64 encoded.
+ *
+ *             Base64_Encode takes as a parameter a pointer to a BUFFER. If @p input is @c NULL then
+ *             @c Base64_Encode returns @c NULL. The size of the BUFFER pointed to by @p input may
+ *             be zero. If when allocating memory to produce the encoding a failure occurs, then @c
+ *             Base64_Encode returns @c NULL. Otherwise
+ *             @c Base64_Encode returns a pointer to a STRING. That string contains the
+ *             base 64 encoding of the @p input. This encoding of @p input will not contain embedded
+ *             line feeds.
+ *
+ * @return    A @c STRING_HANDLE containing the base64 encoding of @p input.
+ */
+MOCKABLE_FUNCTION(, STRING_HANDLE, Azure_Base64_Encode, BUFFER_HANDLE, input);
+
+/**
+ * @brief    Base64 encodes the buffer pointed to by @p source and returns the resulting string.
+ *
+ * @param    source    The buffer that needs to be base64 encoded.
+ * @param    size      The size.
+ *
+ *             This function produces a @c STRING_HANDLE containing the base64 encoding of the
+ *             buffer pointed to by @p source, having the size as given by
+ *             @p size. If @p source is @c NULL then @c Base64_Encode_Bytes returns @c NULL
+ *             If @p source is not @c NULL and @p size is zero, then @c Base64_Encode_Bytes produces
+ *             an empty @c STRING_HANDLE. Otherwise, @c Base64_Encode_Bytes produces a
+ *             @c STRING_HANDLE containing the Base64 representation of the buffer. In case of
+ *             any errors, @c Base64_Encode_Bytes returns @c NULL.].
+ *
+ * @return    @c NULL in case an error occurs or a @c STRING_HANDLE containing the base64 encoding
+ *             of @p input.
+ *
+ */
+MOCKABLE_FUNCTION(, STRING_HANDLE, Azure_Base64_Encode_Bytes, const unsigned char*, source, size_t, size);
+
+/**
+ * @brief    Base64 decodes the buffer pointed to by @p source and returns the resulting buffer.
+ *
+ * @param    source    A base64 encoded string buffer.
+ *
+ *           This function decodes the string pointed at by @p source using base64 decoding and
+ *             returns the resulting buffer. If @p source is @c NULL then
+ *             @c Azure_Base64_Decode returns NULL. If the string pointed to by @p source is zero
+ *             length then the handle returned refers to a zero length buffer. If there is any
+ *             memory allocation failure during the decode or if the source string has an invalid
+ *             length for a base 64 encoded string then @c Azure_Base64_Decode returns @c NULL.
+ *
+ * @return    A @c BUFFER_HANDLE pointing to a buffer containing the result of base64 decoding @p
+ *             source.
+ */
+MOCKABLE_FUNCTION(, BUFFER_HANDLE, Azure_Base64_Decode, const char*, source);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* BASE64_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/buffer_.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/buffer_.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/buffer_.h	(revision 389)
@@ -0,0 +1,44 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef BUFFER_H
+#define BUFFER_H
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C"
+{
+#else
+#include <stddef.h>
+#include <stdbool.h>
+#endif
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+typedef struct BUFFER_TAG* BUFFER_HANDLE;
+
+MOCKABLE_FUNCTION(, BUFFER_HANDLE, BUFFER_new);
+MOCKABLE_FUNCTION(, BUFFER_HANDLE, BUFFER_create, const unsigned char*, source, size_t, size);
+MOCKABLE_FUNCTION(, BUFFER_HANDLE, BUFFER_create_with_size, size_t, buff_size);
+MOCKABLE_FUNCTION(, void, BUFFER_delete, BUFFER_HANDLE, handle);
+MOCKABLE_FUNCTION(, int, BUFFER_pre_build, BUFFER_HANDLE, handle, size_t, size);
+MOCKABLE_FUNCTION(, int, BUFFER_build, BUFFER_HANDLE, handle, const unsigned char*, source, size_t, size);
+MOCKABLE_FUNCTION(, int, BUFFER_append_build, BUFFER_HANDLE, handle, const unsigned char*, source, size_t, size);
+MOCKABLE_FUNCTION(, int, BUFFER_unbuild, BUFFER_HANDLE, handle);
+MOCKABLE_FUNCTION(, int, BUFFER_enlarge, BUFFER_HANDLE, handle, size_t, enlargeSize);
+MOCKABLE_FUNCTION(, int, BUFFER_shrink, BUFFER_HANDLE, handle, size_t, decreaseSize, bool, fromEnd);
+MOCKABLE_FUNCTION(, int, BUFFER_content, BUFFER_HANDLE, handle, const unsigned char**, content);
+MOCKABLE_FUNCTION(, int, BUFFER_size, BUFFER_HANDLE, handle, size_t*, size);
+MOCKABLE_FUNCTION(, int, BUFFER_append, BUFFER_HANDLE, handle1, BUFFER_HANDLE, handle2);
+MOCKABLE_FUNCTION(, int, BUFFER_prepend, BUFFER_HANDLE, handle1, BUFFER_HANDLE, handle2);
+MOCKABLE_FUNCTION(, int, BUFFER_fill, BUFFER_HANDLE, handle, unsigned char, fill_char);
+MOCKABLE_FUNCTION(, unsigned char*, BUFFER_u_char, BUFFER_HANDLE, handle);
+MOCKABLE_FUNCTION(, size_t, BUFFER_length, BUFFER_HANDLE, handle);
+MOCKABLE_FUNCTION(, BUFFER_HANDLE, BUFFER_clone, BUFFER_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif  /* BUFFER_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/condition.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/condition.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/condition.h	(revision 389)
@@ -0,0 +1,72 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CONDITION_H
+#define CONDITION_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/lock.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef void* COND_HANDLE;
+
+#define COND_RESULT_VALUES \
+    COND_OK, \
+    COND_INVALID_ARG, \
+    COND_ERROR, \
+    COND_TIMEOUT \
+
+/**
+* @brief Enumeration specifying the lock status.
+*/
+MU_DEFINE_ENUM(COND_RESULT, COND_RESULT_VALUES);
+
+/**
+* @brief	This API creates and returns a valid condition handle.
+*
+* @return	A valid @c COND_HANDLE when successful or @c NULL otherwise.
+*/
+MOCKABLE_FUNCTION(, COND_HANDLE, Condition_Init);
+
+/**
+* @brief	unblock all currently working condition.
+*
+* @param	handle	A valid handle to the lock.
+*
+* @return	Returns @c COND_OK when the condition object has been
+* 			destroyed and @c COND_ERROR when an error occurs
+* 			and @c COND_TIMEOUT when the handle times out.
+*/
+MOCKABLE_FUNCTION(, COND_RESULT, Condition_Post, COND_HANDLE, handle);
+
+/**
+* @brief	block on the condition handle unti the thread is signalled
+*           or until the timeout_milliseconds is reached.
+*
+* @param	handle	A valid handle to the lock.
+*
+* @return	Returns @c COND_OK when the condition object has been
+* 			destroyed and @c COND_ERROR when an error occurs
+* 			and @c COND_TIMEOUT when the handle times out.
+*/
+MOCKABLE_FUNCTION(, COND_RESULT, Condition_Wait, COND_HANDLE, handle, LOCK_HANDLE, lock, int, timeout_milliseconds);
+
+/**
+* @brief	The condition instance is deinitialized.
+*
+* @param	handle	A valid handle to the condition.
+*
+* @return	Returns @c COND_OK when the condition object has been
+* 			destroyed and @c COND_ERROR when an error occurs.
+*/
+MOCKABLE_FUNCTION(, void, Condition_Deinit, COND_HANDLE, handle);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* CONDITION_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/connection_string_parser.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/connection_string_parser.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/connection_string_parser.h	(revision 389)
@@ -0,0 +1,25 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CONNECTION_STRING_PARSER_H
+#define CONNECTION_STRING_PARSER_H
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+#include "azure_c_shared_utility/map.h" 
+#include "azure_c_shared_utility/strings.h"
+
+#ifdef __cplusplus
+extern "C" 
+{
+#endif
+
+    MOCKABLE_FUNCTION(, MAP_HANDLE, connectionstringparser_parse_from_char, const char*, connection_string);
+    MOCKABLE_FUNCTION(, MAP_HANDLE, connectionstringparser_parse, STRING_HANDLE, connection_string);
+    MOCKABLE_FUNCTION(, int, connectionstringparser_splitHostName_from_char, const char*, hostName, STRING_HANDLE, nameString, STRING_HANDLE, suffixString);
+    MOCKABLE_FUNCTION(, int, connectionstringparser_splitHostName, STRING_HANDLE, hostNameString, STRING_HANDLE, nameString, STRING_HANDLE, suffixString);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* CONNECTION_STRING_PARSER_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/consolelogger.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/consolelogger.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/consolelogger.h	(revision 389)
@@ -0,0 +1,23 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CONSOLELOGGER_H
+#define CONSOLELOGGER_H
+
+#include "azure_c_shared_utility/xlogging.h"
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+    extern void consolelogger_log(LOG_CATEGORY log_category, const char* file, const char* func, int line, unsigned int options, const char* format, ...);
+
+#if (defined(_MSC_VER))
+    extern void consolelogger_log_with_GetLastError(const char* file, const char* func, int line, const char* format, ...);
+#endif
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* CONSOLELOGGER_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/const_defines.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/const_defines.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/const_defines.h	(revision 389)
@@ -0,0 +1,26 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CONST_DEFINES_H
+#define CONST_DEFINES_H
+
+// Used to remove GCC warning unused
+#ifdef __GNUC__
+    #define STATIC_VAR_UNUSED __attribute__ ((unused))
+#else
+    #define STATIC_VAR_UNUSED
+#endif
+
+#ifndef AZURE_UNREFERENCED_PARAMETER
+#define AZURE_UNREFERENCED_PARAMETER(param)   (void)(param)
+#endif
+
+#ifdef _MSC_VER
+#define AZURE_DEPRECATED __declspec(deprecated)
+#elif defined(__GNUC__) | defined(__clang__)
+#define AZURE_DEPRECATED __attribute__((__deprecated__))
+#else
+#define AZURE_DEPRECATED
+#endif
+
+#endif // CONST_DEFINES
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constbuffer.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constbuffer.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constbuffer.h	(revision 389)
@@ -0,0 +1,51 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CONSTBUFFER_H
+#define CONSTBUFFER_H
+
+#include "azure_c_shared_utility/buffer_.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C"
+{
+#else
+#include <stddef.h>
+#endif
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+/*this is the handle*/
+typedef struct CONSTBUFFER_HANDLE_DATA_TAG* CONSTBUFFER_HANDLE;
+
+/*this is what is returned when the content of the buffer needs access*/
+typedef struct CONSTBUFFER_TAG
+{
+    const unsigned char* buffer;
+    size_t size;
+} CONSTBUFFER;
+
+typedef void(*CONSTBUFFER_CUSTOM_FREE_FUNC)(void* context);
+
+/*this creates a new constbuffer from a memory area*/
+MOCKABLE_FUNCTION(, CONSTBUFFER_HANDLE, CONSTBUFFER_Create, const unsigned char*, source, size_t, size);
+
+/*this creates a new constbuffer from an existing BUFFER_HANDLE*/
+MOCKABLE_FUNCTION(, CONSTBUFFER_HANDLE, CONSTBUFFER_CreateFromBuffer, BUFFER_HANDLE, buffer);
+
+MOCKABLE_FUNCTION(, CONSTBUFFER_HANDLE, CONSTBUFFER_CreateWithMoveMemory, unsigned char*, source, size_t, size);
+
+MOCKABLE_FUNCTION(, CONSTBUFFER_HANDLE, CONSTBUFFER_CreateWithCustomFree, const unsigned char*, source, size_t, size, CONSTBUFFER_CUSTOM_FREE_FUNC, customFreeFunc, void*, customFreeFuncContext);
+
+MOCKABLE_FUNCTION(, void, CONSTBUFFER_IncRef, CONSTBUFFER_HANDLE, constbufferHandle);
+
+MOCKABLE_FUNCTION(, void, CONSTBUFFER_DecRef, CONSTBUFFER_HANDLE, constbufferHandle);
+
+MOCKABLE_FUNCTION(, const CONSTBUFFER*, CONSTBUFFER_GetContent, CONSTBUFFER_HANDLE, constbufferHandle);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif  /* CONSTBUFFER_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constmap.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constmap.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/constmap.h	(revision 389)
@@ -0,0 +1,132 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+/** @file       constmap.h
+*	@brief		ConstMap is a module that implements a read-only dictionary
+*           of @c const char* keys to @c const char* values.
+*/
+
+#ifndef CONSTMAP_H
+#define CONSTMAP_H
+
+#include "azure_c_shared_utility/macro_utils.h"
+#include "azure_c_shared_utility/crt_abstractions.h"
+#include "azure_c_shared_utility/map.h"
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C"
+{
+#else
+#include <stddef.h>
+#endif
+
+
+#define CONSTMAP_RESULT_VALUES \
+    CONSTMAP_OK, \
+    CONSTMAP_ERROR, \
+    CONSTMAP_INVALIDARG, \
+    CONSTMAP_KEYNOTFOUND
+
+/** @brief Enumeration specifying the status of calls to various APIs in this  
+ *  module.
+ */ 
+MU_DEFINE_ENUM(CONSTMAP_RESULT, CONSTMAP_RESULT_VALUES);
+ 
+typedef struct CONSTMAP_HANDLE_DATA_TAG* CONSTMAP_HANDLE;
+ 
+
+/**
+ * @brief   Creates a new read-only map from a map handle.
+ *
+ * @param   sourceMap   The map from which we will populate key,value
+ *                      into the read-only map.
+ *
+ * @return  A valid @c CONSTMAP_HANDLE or @c NULL in case an error occurs.
+ */
+MOCKABLE_FUNCTION(, CONSTMAP_HANDLE, ConstMap_Create, MAP_HANDLE, sourceMap);
+
+ /** 
+  * @brief  Destroy a read-only map.  Deallocate memory associated with handle.
+  * @param  handle      Handle to a read-only map.
+  */
+MOCKABLE_FUNCTION(, void, ConstMap_Destroy, CONSTMAP_HANDLE, handle);
+
+ /** 
+  * @brief  Clone a read-only map from another read-only map. 
+  * @param  handle      Handle to a read-only map.
+  * @return A valid @c CONSTMAP_HANDLE or @c NULL in case an error occurs.
+  */
+MOCKABLE_FUNCTION(, CONSTMAP_HANDLE, ConstMap_Clone, CONSTMAP_HANDLE, handle);
+
+ /** 
+  * @brief  Create a map handle populated from the read-only map.
+  * @param  handle      Handle to a read-only map.
+  * @return A valid @c MAP_HANDLE or @c NULL in case an error occurs.
+  *  
+  * The new MAP_HANDLE needs to be destroyed when it is no longer needed.
+  */
+MOCKABLE_FUNCTION(, MAP_HANDLE, ConstMap_CloneWriteable, CONSTMAP_HANDLE, handle);
+
+/**
+ * @brief   This function returns a true if the map contains a key 
+ *			with the same value the parameter @p key.
+ *
+ * @param   handle      The handle to an existing map.
+ * @param   key         The key that the caller wants checked.
+ *
+ * @return				The function returns @c true if the key exists 
+ *						in the map and @c false if key is not found or 
+ *						parameters are invalid.
+ */
+MOCKABLE_FUNCTION(, bool, ConstMap_ContainsKey, CONSTMAP_HANDLE, handle, const char*, key);
+
+/**
+ * @brief   This function returns @c true if at least one <key,value> pair 
+ *			exists in the map where the entry's value is equal to the 
+ *			parameter @c value.
+ *
+ * @param   handle          The handle to an existing map.
+ * @param   value           The value that the caller wants checked.
+ *
+ * @return					The function returns @c true if the value exists 
+ *							in the map and @c false if value is not found or 
+ *							parameters are invalid.
+ */
+MOCKABLE_FUNCTION(, bool, ConstMap_ContainsValue, CONSTMAP_HANDLE, handle, const char*, value);
+
+/**
+ * @brief   Retrieves the value of a stored key.
+ *
+ * @param   handle  The handle to an existing map.
+ * @param   key     The key to be looked up in the map.
+ *
+ * @return  Returns @c NULL in case the input arguments are @c NULL or if the
+ *          requested key is not found in the map. Returns a pointer to the
+ *          key's value otherwise.
+ */
+MOCKABLE_FUNCTION(, const char*, ConstMap_GetValue, CONSTMAP_HANDLE, handle, const char*, key);
+ 
+ /**
+ * @brief   Retrieves the complete list of keys and values from the map
+ *          in @p values and @p keys. Also writes the size of the list
+ *          in @p count.
+ *
+ * @param   handle      The handle to an existing map.
+ * @param   keys        The location where the list of keys is to be written.
+ * @param   values      The location where the list of values is to be written.
+ * @param   count       The number of stored keys and values is written at the
+ *                      location indicated by this pointer.
+ *
+ * @return  Returns @c CONSTMAP_OK if the keys and values are retrieved
+ *                     and written successfully or an error code otherwise.
+ */
+MOCKABLE_FUNCTION(, CONSTMAP_RESULT, ConstMap_GetInternals, CONSTMAP_HANDLE, handle, const char*const**, keys, const char*const**, values, size_t*, count);
+
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* CONSTMAP_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/crt_abstractions.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/crt_abstractions.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/crt_abstractions.h	(revision 389)
@@ -0,0 +1,132 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef CRT_ABSTRACTIONS_H
+#define CRT_ABSTRACTIONS_H
+
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+#ifdef __cplusplus
+#include <cstdio>
+#include <cstring>
+#include <cerrno>
+#include <cmath>
+extern "C" {
+#else // __cplusplus
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+#endif // __cplusplus
+
+#ifdef _MSC_VER
+
+#ifdef QUARKGALILEO
+#define HAS_STDBOOL
+#ifdef __cplusplus
+typedef bool _Bool;
+#else
+/*galileo apparently has _Bool and bool as built in types*/
+#endif
+#endif // QUARKGALILEO
+
+#define HAS_STDBOOL
+#ifdef __cplusplus
+/*because C++ doesn't do anything about _Bool... */
+#define _Bool bool
+#else // __cplusplus
+#include <stdbool.h>
+#endif // __cplusplus
+
+#else //  _MSC_VER
+
+#if defined __STDC_VERSION__
+#if ((__STDC_VERSION__  == 199901L) || (__STDC_VERSION__ == 201000L) || (__STDC_VERSION__ == 201112L))
+/*C99 compiler or C11*/
+#define HAS_STDBOOL
+#include <stdbool.h>
+#endif //  ((__STDC_VERSION__  == 199901L) || (__STDC_VERSION__ == 201000L) || (__STDC_VERSION__ == 201112L))
+#endif // __STDC_VERSION__
+#endif //  _MSC_VER
+
+#ifndef HAS_STDBOOL
+#ifdef __cplusplus
+#define _Bool bool
+#else // __cplusplus
+typedef unsigned char _Bool;
+typedef unsigned char bool;
+#define false 0
+#define true 1
+#endif // __cplusplus
+#endif // HAS_STDBOOL
+
+
+/* Codes_SRS_CRT_ABSTRACTIONS_99_001:[The module shall not redefine the secure functions implemented by Microsoft CRT.] */
+/* Codes_SRS_CRT_ABSTRACTIONS_99_040 : [The module shall still compile when building on a Microsoft platform.] */
+/* Codes_SRS_CRT_ABSTRACTIONS_99_002: [CRTAbstractions module shall expose the following API]*/
+#if defined (_MSC_VER) || defined (MINGW_HAS_SECURE_API)
+#else // _MSC_VER || MINGW_HAS_SECURE_API
+
+/* Adding definitions from errno.h & crtdefs.h */
+#if !defined (_TRUNCATE)
+#define _TRUNCATE ((size_t)-1)
+#endif  /* !defined (_TRUNCATE) */
+
+#if !defined STRUNCATE
+#define STRUNCATE       80
+#endif  /* !defined (STRUNCATE) */
+
+extern int strcpy_s(char* dst, size_t dstSizeInBytes, const char* src);
+extern int strcat_s(char* dst, size_t dstSizeInBytes, const char* src);
+extern int strncpy_s(char* dst, size_t dstSizeInBytes, const char* src, size_t maxCount);
+extern int sprintf_s(char* dst, size_t dstSizeInBytes, const char* format, ...);
+#endif // _MSC_VER || MINGW_HAS_SECURE_API
+
+extern unsigned long long strtoull_s(const char* nptr, char** endPtr, int base);
+extern float strtof_s(const char* nptr, char** endPtr);
+extern long double strtold_s(const char* nptr, char** endPtr);
+
+#ifdef _MSC_VER
+#define stricmp _stricmp
+#endif // _MSC_VER
+
+MOCKABLE_FUNCTION(, int, mallocAndStrcpy_s, char**, destination, const char*, source);
+MOCKABLE_FUNCTION(, int, unsignedIntToString, char*, destination, size_t, destinationSize, unsigned int, value);
+MOCKABLE_FUNCTION(, int, size_tToString, char*, destination, size_t, destinationSize, size_t, value);
+
+/*following logic shall define the TOUPPER and ISDIGIT, we do that because the SDK is not happy with some Arduino implementation of it.*/
+#define TOUPPER(c)      ((((c)>='a') && ((c)<='z'))?(c)-'a'+'A':c)
+#define ISDIGIT(c)      ((((c)>='0') && ((c)<='9'))?1:0)
+
+/*following logic shall define the ISNAN macro*/
+/*if runing on Microsoft Visual C compiler, than ISNAN shall be _isnan*/
+/*else if running on C99 or C11, ISNAN shall be isnan*/
+/*else if running on C89 ... #error and inform user*/
+
+#ifdef _MSC_VER
+#define ISNAN _isnan
+#else // _MSC_VER
+#if defined __STDC_VERSION__
+#if ((__STDC_VERSION__  == 199901L) || (__STDC_VERSION__ == 201000L) || (__STDC_VERSION__ == 201112L))
+/*C99 compiler or C11*/
+#define ISNAN isnan
+#else //  ((__STDC_VERSION__  == 199901L) || (__STDC_VERSION__ == 201000L) || (__STDC_VERSION__ == 201112L))
+#error update this file to contain the latest C standard.
+#endif // ((__STDC_VERSION__  == 199901L) || (__STDC_VERSION__ == 201000L) || (__STDC_VERSION__ == 201112L))
+#else // __STDC_VERSION__
+#ifdef __cplusplus
+/*C++ defines isnan... in C11*/
+extern "C++" {
+#define ISNAN std::isnan
+}
+#else // __cplusplus
+#error unknown (or C89) compiler, provide ISNAN with the same meaning as isnan in C99 standard
+#endif // __cplusplus
+
+#endif // __STDC_VERSION__
+#endif // _MSC_VER
+
+#ifdef __cplusplus
+}
+#endif // __cplusplus
+
+#endif /* CRT_ABSTRACTIONS_H */
Index: azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/doublylinkedlist.h
===================================================================
--- azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/doublylinkedlist.h	(revision 389)
+++ azure_iot_hub/trunk/azure_iothub/c-utility/inc/azure_c_shared_utility/doublylinkedlist.h	(revision 389)
@@ -0,0 +1,42 @@
+// Copyright (c) Microsoft. All rights reserved.
+// Licensed under the MIT license. See LICENSE file in the project root for full license information.
+
+#ifndef DOUBLYLINKEDLIST_H
+#define DOUBLYLINKEDLIST_H
+
+#ifdef __cplusplus
+#include <cstddef>
+extern "C"
+{
+#else
+#include <stddef.h>
+#endif
+
+#include <stdint.h>
+#include "azure_c_shared_utility/umock_c_prod.h"
+
+typedef struct DLIST_ENTRY_TAG
+{
+    struct DLIST_ENTRY_TAG *Flink;
+    struct DLIST_ENTRY_TAG *Blink;
+} DLIST_ENTRY, *PDLIST_ENTRY;
+
+MOCKABLE_FUNCTION(, void, DList_InitializeListHead, PDLIST_ENTRY, listHead);
+MOCKABLE_FUNCTION(, int, DList_IsListEmpty, const PDLIST_ENTRY, listHead);
+MOCKABLE_FUNCTION(, void, DList_InsertTailList, PDLIST_ENTRY, listHead, PDLIST_ENTRY, listEntry);
+MOCKABLE_FUNCTION(, void, DList_InsertHeadList, PDLIST_ENTRY, listHead, PDLIST_ENTRY, listEntry);
+MOCKABLE_FUNCTION(, void, DList_AppendTailList, PDLIST_ENTRY, listHead, PDLIST_ENTRY, ListToAppend);
+MOCKABLE_FUNCTION(, int, DList_RemoveEntryList, PDLIST_ENTRY, listEntry);
+MOCKABLE_FUNCTION(, PDLIST_ENTRY, DList_RemoveHeadList, PDLIST_ENTRY, listHead);
+
+//
+// Calculate the address of the base of the structure given its type, and an
+// address of a field within the structure.
+//
+#define containingRecord(address, type, field) ((type *)((uintptr_t)(address) - offsetof(type,field)))
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* DOUBLYLINKEDLIST_H */
